'''
Created on Mar 21, 2010

@author: john
'''

import os

#simply build a dictionary with extensions as keys and lists of files as values
def recursiveHopper(path,verbose):
    files = dict()
    if os.path.isdir(path):
        if verbose: print 'Entering: '+path
        for entity in os.listdir(path):
            fullpath = os.path.join(path,entity)
            combineDicts(files,recursiveHopper(fullpath,verbose))
    else:
        ext = os.path.splitext(path)[1]
        if ext in files: files[ext].append(path)
        else: files[ext] = [path]
    return files

#replaces dict1 with the combination
def combineDicts(dict1,dict2):
    for key in dict1.keys():
        if key in dict2:
            dict1[key].extend(dict2[key])
    for key in dict2.keys():
        if not key in dict1:
            dict1[key] = dict2[key]

#dictionary = recursiveHopper('/home/john/sampleData')
#for key in dictionary:
#    print key
#    print dictionary[key]