'''
Created on Mar 22, 2010

@author: john
'''
import os
import sys
import musicdns, musicdns.cache
import fs.file
import threading

def getpuid(fn):
    musicdns_key = '537d9b1fe8fec202f65710d34816b916'
    musicdns.initialize()
    cache = musicdns.cache.MusicDNSCache()
    puid=''
    try:
        puid, duration = cache.getpuid(fn, musicdns_key)
    except IOError:
        print >> sys.stderr, "Error decoding: %s" % fn
        
    musicdns.finalize()
    return puid

def getpuids(files,count):
    musicdns_key = '537d9b1fe8fec202f65710d34816b916'
    musicdns.initialize()
    cache = musicdns.cache.MusicDNSCache()
    for fl in files:
        #print fl.puid
        if fl.verifyExists() and (fl.puid == None):
            try:
                fl.puid, fl.duration = cache.getpuid(fl.getPath(), musicdns_key)
            except IOError, e:
                print >> sys.stderr, "Error decoding: %s" % fl.path
                print >> sys.stderr, e
            except Exception, e:
                print >> sys.stderr, e
        count[0] += 1
    musicdns.finalize()

class GetPuids(threading.Thread):
    def __init__(self, files,count):
        threading.Thread.__init__(self)
        self.files = files
        self.count = count
        
    def run(self):
        getpuids(self.files, self.count)
        